<template>
<v-dialog :value="value" @input="$emit('input')" persistent scrollable max-width="700px">
  <v-card>
  <v-card-text>
  <v-stepper
    v-model="e1"
    alt-labels
  >
     <template>
      <v-stepper-header>
        <template v-for="(n,index) in steps">
          <v-stepper-step
            :key="`${index+1}-step`"
            :complete="e1 > index+1"
            :step="index+1"
          >
          <span class="text-center">{{ n }}</span>
          </v-stepper-step>
          <v-divider
            v-if="index+1 !== steps.length"
            :key="index+1"
          ></v-divider>
        </template>
      </v-stepper-header>
      <v-stepper-items>
        <v-stepper-content
          v-for="(n,index) in steps"
          :key="`${index+1}-content`"
          :step="index+1"
        >
         <div class="content-header" v-if="index > 0">
            <v-btn x-small @click="goBack(index+1)" text class="btnback">
              <i class="fas fa-chevron-left"></i> Regresar
            </v-btn>
          </div>
          <div v-if="index+1 == 1">
            <st-first-step
              :appointment="appointment"
              @next="nextStep(index+1, $event)"
              @cancel="$emit('input')"
            />
          </div>
          <div v-if="index+1 == 2">
            <st-second-step
              :loading="registerLoading"
              :appointment="appointment"
              :idUnitTutorship="idUnitTutorship"
              @next="registerAppointment($event)"
              @cancel="$emit('input')"
            />
          </div>
        </v-stepper-content>
      </v-stepper-items>
    </template>
  </v-stepper>
    </v-card-text>
</v-card>
</v-dialog>
</template>

<script>
import FirstStep from '@/components/student/RequestAppointmentFirstStep'
import SecondStep from '@/components/student/RequestAppointmentSecondStep'

export default {
  props:{
    value: Boolean,
    appointment: Object,
    idUnitTutorship: String
  },
  data () {
    return{
      registerLoading: false,
      faculty:{},
      e1: 1,
      steps:[
      'Verificar estado de última cita',
      'Selección de fecha con tutor'
      ],
    }
  },
  components:{
    'st-first-step': FirstStep,
    'st-second-step': SecondStep,
  },
  methods:{
    goBack(n){
      this.e1 = n - 1;
    },
    nextStep(n, data) {
        this.e1 = n + 1
    },
    async registerAppointment(data) {
      try {
        this.registerLoading = true;
        // validating all data
        let toSend = {
          alumnos: [this.appointment.student.idAlumno],
          idUnidad: this.idUnitTutorship,
          idTutoria: this.$route.params.id,
          sesion: {
            idTutorAsignado: data.idTutor,
            fechaInicio: data.start,
            fechaFin: data.end
          }
        };
        const response = await this.$api.registerAppointment(toSend);
        this.$emit('refreshData');
      } catch (error) { console.error(error); }
      this.registerLoading = false;
    }
  }
}
</script>
<style scoped lang="scss">
/* scope for encapsulate css */
.v-card__text{
  padding:0 !important
}
</style>
